# Braille IME Helper
2.4 版

## 簡介
點字輸入法助手 (BrlIMEHelper) 讓使用者可以直接用點字顯示器上的點字鍵盤輸入國字。當沒有點字鍵盤可用時，本附加元件也能夠把電腦鍵盤模擬成點字鍵盤。使用此附加元件將點字輸入轉換成輸入法的操作，熟練點字規則的使用者不必學習其他輸入法或者鍵盤排列方式，也能打出國字。目前，本附加元件的實作基於台灣廣泛使用的[注音點字](http://class.kh.edu.tw/19061/bulletin/msg_view/75)與微軟注音輸入法，未來本附加元件的概念也可以延伸到別的點字系統與輸入法。

## 功能
1. 用點字鍵盤輸入中文（與標點符號、數學符號等）。
2. 把電腦鍵盤模擬成點字鍵盤。
3. 能同時使用系統或 NVDA 組合鍵。
4. 不同視窗可以使用不同輸入狀態。
5. 支援瀏覽器密碼輸入。
6. 各式各樣來自使用者回饋之客製化設定選項。

## 系統環境需求
安裝之前，請使用者先確認這些環境設定：（譯註：由於台灣本土化團隊在 2018 年間曾調整許多翻譯用語，以下內容將以最新版 NVDA 為準。）

- NVDA 2017.3 或以上之版本。
- 輸入法必須有適當設定，詳情請見下一段。
- 如果您想要用電腦鍵盤來模擬點字鍵盤，必須先確認它支援 NKRO (N-key rollover)。（譯註：許多遊戲的操作也需要此特性來配合，因此選擇鍵盤時請留意它是否能用來「打遊戲」。）參見： [What PC keyboards allow for 6-key braille data entry?](https://www.duxburysystems.com/faq2.asp?faq=32&fbclid=IwAR0zdRHClvT5gikN_RqAEX_phxEp51HZX9dtDGUkWU5gTprmvBUPyBs5cFk)
- 請避免同時執行「點字輸入法助手」與其他關於點字輸入的程式或附加元件，如附加元件 [PC Keyboard Braille Input for NVDA](https://addons.nvda-project.org/addons/pcKeyboardBrailleInput.en.html) 及[點字酷音](https://github.com/EasyIME/PIME "PIME 輸入法")輸入法等。
- 建議停用 NVDA 設定中「輸入法組字」的「讀出輸入的組字字元」，以享受迅速流暢的打字體驗。
- 建議將「輸入轉譯表」設為「英文（美國）八點（電腦）」，使 NVDA 行為比較符合台灣使用者的操作習慣。

本附加元件假設使用者對微軟注音有如下的設定，但是使用者也可以調整本附加元件的相關設定選項來配合實際狀況。

| Windows 版本 | Windows 10 2004 或以上 | Vista 至 Windows 10 1909 | Windows XP Service Pack 3 |
| ------------ | ------------------------ | ---------------------- | ------------------------- |
| 預設輸入法 | 微軟注音 | 微軟注音 | 美式鍵盤 |
| 預設輸入模式 | 英數 | 英數 | 中文（新注音） |
| 輸入模式切換 | `[Ctrl]+[Space]` | 左邊 `[Shift]` | `[Ctrl]+[Space]` |
| 鍵盤排列方式 | 標準注音鍵盤 | 標準注音鍵盤 | 標準注音鍵盤 |
| 備註 | &nbsp; | &nbsp; | 用 `[Ctrl]+[Space]` 在美式鍵盤和新注音之間切換。 |

## 操作方式

### 快速鍵

本附加元件提供電腦鍵盤和點字鍵盤的快速鍵。介紹它之前，請讀者先理解下列用語：

1. 電腦鍵盤：包含主鍵盤與九宮格數字鍵。其按鍵名稱在本節中會以中括號夾注。
2. 點字鍵：共九個，分別代表點字第 1 至 8 點及點字空白。使用者可以依照輸入轉譯表的規則用它來打字。
3. 點字鍵盤：通常是點顯器上有九個點字鍵組成點字鍵盤。不過，本附加元件也提供一個由電腦鍵盤模擬而來的虛擬點字鍵盤，讓喜歡打點字的使用者方便操作。
4. 點字圖案：點字的外觀，更清楚地說就是這些點字方由哪些點組成。

#### 電腦鍵盤

以下總表列出使用者必須知道最基本的電腦鍵盤快速鍵。本附加元件提供三種做法幫助使用者以點字的方式來打字：點字輸入模式、一般輸入模式和逐點輸入方式，在接下來的三個子章節內說明。

* NvDA+Ctrl+6: 啟用／停用電腦鍵盤模擬點字鍵盤功能。
* F, D, S, J, K, L, A, 分號鍵 `[;:]` 與空白鍵：點字第 1 到 8 點與點字空格。
* 0 到 9: 保留給輸入數字與指定候選字。
* 數字鍵盤（可選功能，且 Num Lock 必須為開）：一個點一個點地輸入點字方。
    + 0 到 8: 點字空格及 1 到 8 點。
    + 9: 清除未打完的點字方。
    + 小數點 `[.]`: 完成一個點字方的輸入。
    + 除號 `[/]`: 檢視打到一半未送出的點字方。
* NVDA+PrintScreen: 複製點字顯示器所顯示的純文字內容到剪貼簿。
    + 按一下：複製這一行。
    + 快按兩下：複製這一行以及焦點物件提示。
* NVDA+Win+PrintScreen: 複製點字顯示器上呈現的點字內容到剪貼簿。
    + 按一下：複製目前顯示的點字方。
    + 快按兩下：複製這一行所有點字方。

##### 點字輸入模式

這是預設的模式，電腦鍵盤上的九個鍵被拿來模擬實體點字鍵盤，預設為 F, D, S, J, K, L, A, 分號鍵 `[;:]` 與空白鍵。NVDA 處理模擬點字鍵盤所送出的訊息，過程與處理實體點字鍵盤送出的點字輸入訊息一樣。因此，它們讓使用者可以用輸入轉譯表的（點字）規則打字，以及送出點字鍵組成的快速鍵。

注意：此模擬的點字鍵盤輸入成功與否還要取決於電腦鍵盤本身的物理限制。對沒有做到「全鍵無衝」的鍵盤來說，可能有些鍵兩個一起按下卻只會產生按下其中一個鍵的效果。在回報此模擬點字鍵盤導致的不合理反應之前，請先用 NVDA 輸入說明來檢查所產生的點字輸入是否正確。

##### 一般輸入模式

一般輸入模式也幫助使用者用點字方式打字，尤其是熟悉電腦鍵盤但不適應輸入法鍵盤配置的使用者。它跟點字輸入模式的不同之處在於按鍵與點字圖案間的關係。一個按鍵（可能隨著或不跟隨 Shift）對應到一種點字圖案，這個關係定義在「輸出轉譯表」中。下列兩個例子用來幫助讀者瞭解它的操作和效果。

範例 1:

1. 將輸出轉譯表及輸入轉譯表分別設為「中文 (台灣) 注音」與「Unicode」。
2. 在一般輸入模式中，把微軟注音設定成英數輸入。
3. 在編輯區裡打字，就像沒有在模擬什麼點字鍵盤那樣。

三個步驟過後，您會發現編輯區裡的內容摸起來跟剛才打的字一樣，可是實際上它是由 Unicode 點字字元構成，顯示出剛才您輸入點字的過程。也就是說，假如輸入轉譯表不是「Unicode」，這些 Unicode 點字字元會在打出來之前被轉譯回普通的英數符號。

範例 2: (尚未實作完成)

1. 將輸出轉譯表設為「中文 (台灣) 注音」，輸入轉譯表沒有限制。
2. 在一般輸入模式中，把微軟注音設定成中文輸入。
3. 在編輯區裡打 5 個字元： `a&'=1`

三個步驟之後，您會發現組字區顯示「中文」或者其他也讀ㄓㄨㄥㄨㄣˊ的同音異字。也就是說，「中文」和 `a&'=1` 的點字一樣都是 ⠁⠯⠄⠿⠂。

有些使用者習慣用點字的方式來輸入，但是他們手指關節不夠靈活導致操作實體點字鍵盤或點字輸入模式錯誤百出。設計出一般輸入模式即是讓他們的輸入過程變得方便。當觸摸點字時，讀者會經常想到它代表的是哪個字元，而不是它包含第幾點。反過來說，用那些字元來表示想要輸入的點位對使用者而言也一樣簡單。在此模式中，本附加元件根據當下的點字輸出轉譯表將電腦鍵盤上所按的鍵轉譯成點字輸入訊息。例如，目前的點字輸出轉譯表規定把 "f" 轉譯成 ⠋，那麼在電腦鍵盤上按出小寫 f 就代表點字輸入是輸入 ⠋。換句話說，用電腦鍵盤打出 "f" 就等於在點字鍵盤同時按下第 1, 2, 4 點。

就如上面兩個例子所示，平常的設定之下一般輸入模式在輸入法英數輸入的時候並沒有作用，因此它又可以當成本附加元件 2.3 版之前版本「在輸入法英數模式中不模擬點字鍵盤」的延伸。

注意：點字快速鍵在此模式中的按法仍遵循點字輸入模式的規則，用點字空白與其餘點字鍵 1 到 8 點同時按下。

註：如果按下空白鍵結果不是打出點字空格 (⠀)，那是舊版 NVDA 的錯誤所導致，請更新 NVDA 版本來解決此問題。

##### 逐點輸入方式

逐點（一個點一個點）的輸入方式獨立於其他兩個點字鍵盤模擬的模式之外。若它被啟用，使用者可在數字鎖定鍵 (Num Lock) 開啟的情況下用數字鍵盤打出每一方點字中第幾點的編號來輸入。例如 `[1][2][.] [1][2][3][5][.] [1][2][3][.]` 會在編輯區裡打出 "brl"。數字鍵盤鍵的功能就寫在本段落一開始的總表之中。這種方式允許使用者無論電腦鍵盤有什麼物理限制都能送出超過 6 個點（或空白）組成的點字快速鍵。

#### 點字快速鍵

點字快速鍵是由點字空白與其他點位構成。它讓使用者透過點字鍵盤來執行某項功能或者模擬某個電腦鍵盤上的快速鍵。有了這些點字快速鍵，使用者可以減少其雙手離開點字鍵的機會，因而提昇操作的效率。

接下來兩個小節介紹點字快速鍵。第一個小節中，列出一些常用的點字快速鍵，並且建議使用者如何快速記住它們。第二個小節用表列出所有本附加元件制定的點字快速鍵。請注意，執行點字輸入法助手功能的點字快速鍵在實體或者虛擬的點字鍵盤上都能使用，但是其他點字快速鍵只能用虛擬點字鍵盤來操作。

為了始本節之後的說明簡潔，點字快速鍵就只用點位來描述，不再提到點字空白。

相容性警告：在不到 2018.3 的 NVDA 版本中，點字輸入的來源不能是「不使用點顯器」，所以本附加元件產生的模擬點字輸入來自「點字鍵盤」（譯註：「點字鍵盤」指的是任意點顯器的點字鍵盤，可以將「輸入手勢」的設定套用在所有品牌、型號的點顯器上）。若沒有針對正在使用的點顯器設定點字快速鍵，實體點字鍵盤的操作也會變成執行本附加元件定義之功能，而這個行為不會發生在較新的 NVDA 版本中。

##### 常用點字快速鍵

<b>點字輸入法助手類</b>

| 點位（加上點字空白） | 功能 | 速記方法 |
| :------------------- | :--- | :------- |
| 456 | 在輸入法的中文輸入及英數輸入之間切換 | 與「視窗導盲鼠系統」用相同點位 |
| 1   | 查看點字緩衝區 | &nbsp; |
| 245 | 清空點字緩衝區以重新輸入正確內容 | 錯（ㄘㄨㄛˋ）的ㄘ是第 2 4 5 點 |
| 123 | 在輸入法英數輸入中切換模擬點字鍵盤的模式（譯註：可讓電腦鍵盤輸入中文時模擬點字鍵盤，英數輸入時獨立切換點字輸入或一般輸入模式） | 與「視窗導盲鼠系統」用相同點位 |
| 136 | 在 Unicode 點字與其他輸入轉譯表之間切換 | Unicode 的首字母 u 是第 1 3 6 點 |

使用者在中文輸入模式下，打出來的東西在組字完成之前先存在點字緩衝區內。例如只有打 135 126 點還不構成字，但是查看點字緩衝區時會提示已經輸入了ㄅㄛ。

第 2 4 5 點加點字空白有另一個作用。它讓 NVDA 在不改動任何控制項內容的情況下撤除點字訊息

按下第 1 3 6 點 + 點字空白之後，點字的輸入轉譯表會變成「Unicode」（譯註：之前的 NVDA 版本翻譯為「Unicode 點字」）。再按一次會讓它變回使用者先前設定的輸入轉譯表。不過，如果輸入轉譯表一開始就是「Unicode」，則它會變成「英文（美國）八點（電腦）」。

<b>文件編輯類</b>

| 點位（加上點字空白） | 功能 | 速記方法 |
| :------------------- | :--- | :------- |
| 346   | `[`&uarr;`]` 鍵 | &nbsp; |
| 146   | `[`&darr;`]` 鍵 | &nbsp; |
| 126   | `[`&larr;`]` 鍵 | 第 1 2 6 點是一個指向左邊的「小於」 |
| 345   | `[`&rarr;`]` 鍵 | 第 3 4 5 點是一個指向右邊的「大於」 |
| 45    | `[Home]` 鍵（將游標移至行首） | &nbsp; |
| 1246  | `[End]` 鍵（將游標移至行尾） | &nbsp; |
| 246   | Page Up 鍵（將游標移動到上一頁） | &nbsp; |
| 1256  | Page Down 鍵（將游標移動到下一頁） | &nbsp; |
| 1247  | `[Ctrl]+[F]` 鍵（尋找） | 第 7 點 (Ctrl) + 第 1 2 4 點 (f) |
| 17    | `[Ctrl]+[A]` 鍵（全選） | 第 7 點 (Ctrl) + 第 1 點 (a) |
| 147   | `[Ctrl]+[C]` 鍵（複製） | 第 7 點 (Ctrl) + 第 1 4 點 (c) |
| 13467 | `[Ctrl]+[X]` 鍵（剪下） | 第 7 點 (Ctrl) + 第 1 3 4 6 點 (x) |
| 12367 | `[Ctrl]+[V]` 鍵（貼上） | 第 7 點 (Ctrl) + 第 1 2 3 6 點 (v) |
| 13567 | `[Ctrl]+[Z]` 鍵（復原） | 第 7 點 (Ctrl) + 第 1 3 5 6 點 (z) |
| 3456  | `[Delete]` 鍵（移除游標右邊的文字） | 容易把 # 的交叉形狀聯想到「刪除」 |

<b>Windows 系統快速鍵類</b>

| 點位（加上點字空白） | 功能 | 速記方法 |
| :------------------- | :--- | :------- |
| 14    | `[Ctrl]` 鍵（左邊） | 首字母 c 是第 1 4 點 |
| 134   | `[Alt]` 鍵（左邊） | 功能表(menu) 的首字母 m 是第 1 3 4 點 |
| 234   | `[Shift]` 鍵（左邊） | 首字母 s 是第 2 3 4 點 |
| 2456  | `[Win]` 鍵（左邊） | 首字母 w 是第 2 4 5 6 點 |
| 34    | `[Tab]` 鍵 | 首字母 t 包含第 3 4 點 |
| 16    | `[Shift]+[Tab]` 鍵 | 第 1 6 點的形狀與第 3 4 點相反 |
| 12346 | `[App]` 鍵（顯示快顯功能表） | &nbsp; |
| 1346  | `[Alt]+[F4]` 鍵（關閉視窗） | 視窗右上角的 `[X]` 關閉按鈕 |
| 2346  | `[Esc]` 鍵 | &nbsp; |
| 25678 | `[Win]+[D]` 鍵（顯示桌面） | 第 7 8 點 (Win) + 第 2 5 6 點 (d 的下位，也就是 4) |
| 678   | `[Win]+[T]` 鍵（跳轉到工具列） | &nbsp; |
| 27, 237, ..., 357, 3567 | `[F1]` 到 `[F10]` | 第 7 點 + 十個點字數字 |

<b>NVDA 功能類</b>

| 點位（加上點字空白） | 功能 | 速記方法 |
| :------------------- | :--- | :------- |
| 1345  | `[NVDA]+[N]` 鍵（顯示 NVDA 功能表） | 用到的字母鍵是 N |
| 12456 | `[NVDA]+[`&darr;`]` 鍵（從系統游標處往下報讀） | 點位構成拇指指向下的形狀 |
| 12356 | `[NVDA]+[F9]` 鍵（標記開始位置） | 左小括號有「開始」的意思 |
| 23456 | `[NVDA]+[F10]` 鍵（標記結束位置） | 右小括號有「結束」的意思 |
| 2, 23, ..., 35 | 九宮格 1 到 9 （檢閱游標的操作） | 都是下位點字數字 |

##### 所有點字快速鍵

此處表格所列為所有支援的點字快速鍵。

開始閱讀之前，請留意這些點字快速鍵中絕大多數又可依照所用的第 7 8 點歸納出其功能。第 7 點表示此點字快速鍵模擬包含 `[Ctrl]` 的電腦快速鍵或者 `[F1]` 到 `[F12]` 等功能鍵。第 8 點表示此點字快速鍵模擬包含 `[Alt]` 鍵或 `[NVDA]` 鍵的電腦快速鍵。同時有第 7 8 點表示此點字快速鍵模擬包含 `[Ctrl]+[Alt]` 鍵或者 `[Win]` 鍵的電腦快速鍵。無論如何，適當瞭解點字快速鍵的設計原則將會幫助讀者在短時間內記住大量點字快速鍵。

最初設計規劃請見 [nvda-tw 電郵群組的 #3664 號訊息](https://groups.io/g/nvda-tw/message/3664)。

| 點位（加上點字空白） | 功能 | 加第 7 點 | 加第 8 點 | 加 7, 8 點 |
| :------------------- | :--- | :-------- | :-------- | :--------- |
| 1     | 查看點字緩衝區 | `[Ctrl]+[A]` | `[Alt]+[A]` | `[Ctrl]+[Alt]+[A]` |
| 12    | 無 | `[Ctrl]+[B]` | `[Alt]+[B]` | `[Ctrl]+[Alt]+[B]` |
| 14    | `[Ctrl]` | `[Ctrl]+[C]` | `[Alt]+[C]` | `[Ctrl]+[Alt]+[C]` |
| 145   | 無 | `[Ctrl]+[D]` | `[Alt]+[D]` | `[Ctrl]+[Alt]+[D]` |
| 15    | 無 | `[Ctrl]+[E]` | `[Alt]+[E]` | `[Ctrl]+[Alt]+[E]` |
| 124   | 無 | `[Ctrl]+[F]` | `[Alt]+[F]` | `[Ctrl]+[Alt]+[F]` |
| 1245  | 無 | `[Ctrl]+[G]` | `[Alt]+[G]` | 無 |
| 125   | 無 | `[Ctrl]+[H]` | `[Alt]+[H]` | `[Ctrl]+[Alt]+[H]` |
| 24    | 無 | `[Ctrl]+[I]` | `[Alt]+[I]` | `[Ctrl]+[Alt]+[I]` |
| 245   | 清空點字緩衝區 | `[Ctrl]+[J]` | `[Alt]+[J]` | `[Ctrl]+[Alt]+[J]` |
| 13    | 無 | `[Ctrl]+[K]` | `[Alt]+[K]` | `[Ctrl]+[Alt]+[K]` |
| 123   | 在輸入法英數輸入中切換模擬點字鍵盤的模式 | `[Ctrl]+[L]` | `[Alt]+[L]` | `[Ctrl]+[Alt]+[L]` |
| 134   | `[Alt]` | `[Ctrl]+[M]` | `[Alt]+[M]` | `[Ctrl]+[Alt]+[M]` |
| 1345  | 開啟 NVDA 功能表 | `[Ctrl]+[N]` | `[Alt]+[N]` | 無 |
| 135   | 無 | `[Ctrl]+[O]` | `[Alt]+[O]` | `[Ctrl]+[Alt]+[O]` |
| 1234  | 無 | `[Ctrl]+[P]` | `[Alt]+[P]` | 無 |
| 1235  | 無 | `[Ctrl]+[R]` | `[Alt]+[R]` | 無 |
| 234   | `[Shift]` | `[Ctrl]+[S]` | `[Alt]+[S]` | `[Ctrl]+[Alt]+[S]` |
| 2345  | 無 | `[Ctrl]+[T]` | `[Alt]+[T]` | 無 |
| 136   | 在 Unicode 點字與其他輸入轉譯表之間切換 | `[Ctrl]+[U]` | `[Alt]+[U]` | `[Ctrl]+[Alt]+[U]` |
| 1236  | 無 | `[Ctrl]+[V]` | `[Alt]+[V]` | 無 |
| 2456  | `[Win]` | `[Ctrl]+[W]` | `[Alt]+[W]` | 無 |
| 1346  | `[Alt]+[F4]` | `[Ctrl]+[X]` | `[Alt]+[X]` | 無 |
| 1356  | 無 | `[Ctrl]+[Z]` | `[Alt]+[Z]` | 無 |
| 246   | `[PgUp]` | `[Ctrl]+[PgUp]` | `[Alt]+[PgUp]` | 無 |
| 1256  | `[PgDn]` | `[Ctrl]+[PgDn]` | `[Alt]+[PgDn]` | 無 |
| 12456 | 從目前游標所在位置往後讀到結尾 | 無 | 無 | 無 |
| 45    | `[Home]` | `[Ctrl]+[Home]` | `[Alt]+[Home]` | 無 |
| 2346  | `[Esc]` | `[Ctrl]+[Esc]` | `[Alt]+[Esc]` | 無 |
| 3456  | `[Delete]` | `[Ctrl]+[Delete]` | `[Alt]+[Delete]` | 無 |
| 1246  | `[End]` | `[Ctrl]+[End]` | `[Alt]+[End]` | 無 |
| 146   | `[`&darr;`]` | `[Ctrl]+[`&darr;`]` | `[Alt]+[`&darr;`]` | `[Ctrl]+[Alt]+[`&darr;`]` |
| 12346 | `[App]` | 無 | 無 | 無 |
| 12356 | `[NVDA]+[F9]` | 無 | 無 | 無 |
| 23456 | `[NVDA]+[F10]` | 無 | 無 | 無 |
| 16    | `[Shift]+[Tab]` | `[Ctrl]+[Shift]+[Tab]` | `[Alt]+[Shift]+[Tab]` | 無 |
| 346   | `[`&uarr;`]` | `[Ctrl]+[`&uarr;`]` | `[Alt]+[`&uarr;`]` | `[Ctrl]+[Alt]+[`&uarr;`]` |
| 34    | `[Tab]` | `[Ctrl]+[Tab]` | `[Alt]+[Tab]` | 無 |
| 126   | `[`&larr;`]` | `[Ctrl]+[`&larr;`]` | `[Alt]+[`&larr;`]` | `[Ctrl]+[Alt]+[`&larr;`]` |
| 345   | `[`&rarr;`]` | `[Ctrl]+[`&rarr;`]` | `[Alt]+[`&rarr;`]` | `[Ctrl]+[Alt]+[`&rarr;`]` |
| 456   | 在輸入法的中文輸入及英數輸入之間切換 | 無 | 無 | 無 |
| 2     | 檢閱游標移到前一個字元，並讀出 | `[F1]` | 切換到前一個檢閱模式 | `[Win]+[A]` |
| 23    | 讀出檢閱游標所在導航物件的字元 | `[F2]` | 將導航器移至第一個子物件 | `[Win]+[B]` |
| 25    | 檢閱游標移到導航器物件的後一個字元，並讀出 | `[F3]` | 無 | `[Win]+[X]` |
| 256   | 檢閱游標移到導航物件的前一個字詞，並讀出 | `[F4]` | 將導航器移到前一個物件 | `[Win]+[D]` |
| 26    | 讀出檢閱游標所在字元的字詞 | `[F5]` | 報讀目前的導航器物件 | 無 |
| 235   | 檢閱游標移到導航物件的後一個字詞，並讀出 | `[F6]` | 將導航器移到後一個物件 | 無 |
| 2356  | 檢閱游標移到上一行，並讀出 | `[F7]` | 切換到後一個檢閱模式 | 無 |
| 236   | 讀出導航器物件所在行的文字 | `[F8]` | 將導航器移到其母物件 | 無 |
| 35    | 檢閱游標移到導航物件的下一行，並讀出 | `[F9]` | 無 | `[Win]+[I]` |
| 356   | 無 | `[F10]` | 執行目前導航器物件的預設動作 | 無 |
| 5     | 在目前鼠標位置點擊滑鼠左鍵一次 | `[F11]` | 將鼠標移到目前的導航器物件 | 無 |
| 56    | 從目前檢閱游標所在的文字往後朗讀直到結尾 | `[F12]` | 無 | 無 |
| 3     | 無 | 無 | 讀出檢閱游標所在的文字或物件的位置資訊 | `[Win]+[Tab]` |
| 36    | 無 | 無 | 若可能的話，將導航器物件移到目前系統焦點，並將檢閱游標移到其內的編輯游標 | 開啟控制台 |
| 6     | 在目前鼠標位置點擊滑鼠右鍵一次 | 無 | 將導航器物件移到鼠標所指的物件並讀出 | `[Win]+[T]` |
| 無 | 點字空白 | `[Win]+[Space]` | `[Alt]+[Space]` | `[Win]+[Shift]+[Space]` |

#### 沒有任何預設快速鍵的功能

##### 強迫 NVDA 持續顯示當前的點字訊息
大部分使用者設定 NVDA 幾秒內撤除當前的點字訊息。如果必須仔細閱讀某個訊息，使用者可以透過自己指定的快速鍵來執行這項功能。訊息會留在點字顯示器上，如同 NVDA 偏好設定中的「持續顯示訊息」核取方塊被勾選。因此，建議使用者將此功能綁定在可以幾秒內完成的快速鍵上。

### 選項

#### 當 NVDA 啟動時自動啟用點字鍵盤模擬
若有勾選，點字鍵盤模擬會在 NVDA 啟動時自動啟用。

#### 切換輸入法英數、中文輸入模式所用的快速鍵

該選項決定按下 4 5 6 點加上點字空白後本附加元件送出的快速鍵指令。為了跟舊版保持行為一致，預設值是左邊 Shift 鍵。

注意：Windows XP 的使用者們，如果要用 `[Ctrl]+[Space]` 來切換美式鍵盤和新注音，請將新注音預設在中文輸入模式。

#### 在輸入法英數輸入中模擬點字鍵盤時預設為 ASCII 模式

此選項延伸自 2.3 版之前的「在輸入法英數模式中預設不模擬點字鍵盤」。若有勾選，輸入法英數輸入中模擬點字鍵盤時的預設模式為 ASCII 模式。模式的細節請參見快速鍵說明中的「電腦鍵盤」段落。

#### 「點字鍵」與「忽略鍵」
使用者可以在「點字輸入法助手設定」對話框中決定電腦鍵盤模擬點字鍵盤的點位、空格以及被忽略（保留）鍵的位置。當焦點停在「點字鍵」或「忽略鍵」選項上時，點字鍵盤模擬會被自動停用。點字鍵必須設定恰好 9 個，但是忽略鍵的數量不限。如果同一個鍵出現在兩個選項中，「點字鍵」選項優先被採用。逐一用鍵盤敲出想要的按鍵位置後，需按下「套用」或者「確定」按鈕才會生效。有時候，「點字鍵」選項可能不會完全有用，因為您電腦（或者筆電）的鍵盤內部設計不支援同時傳送某些按鍵的指令。請您改變設定來找出一組可用的點字鍵。

#### 電腦鍵盤在輸入法英數輸入中模擬點字鍵盤時忽略所有非點字鍵
若有勾選，電腦鍵盤在輸入法英數輸入中模擬點字鍵盤的時候，除了點字鍵以外的所有按鍵均被忽略。

#### 鍵盤對應
這個選項對應到輸入法中文輸入模式中的鍵盤配置設定。（譯註：目前它的候選值完全抄自微軟注音，暫時不支援使用者自訂的鍵盤配置方式。）

#### 模擬點字鍵盤的時候允許透過數字鍵盤（九宮格）進行一個點一個點的點字輸入
若有勾選，使用者可以用數字鍵盤一個點一個點地輸入點字方，此時 Num Lock 需為開啟的狀態。

#### 點字鍵盤模擬的手動／自動切換提示
這兩個選項決定切換點字鍵盤模擬時的提示方式。詳細地說，自動切換可能會發生在前景視窗改變或者本附加元件的設定被修改之後。

#### 所有處理程序的點字鍵盤模擬狀態保持一致
若有勾選，點字鍵盤模擬狀態是唯一的，這也是 2.0 版以前附加元件的行為。否則，本附加元件會獨立記錄每個處理程序的點字鍵盤模擬狀態。允許每個視窗使用不同輸入法的使用者可以取消勾選此選項以減少切換點字鍵盤模擬狀態的次數。注意當此選項從沒有勾選變成有勾選的時後，所有處理程序的點字鍵盤模擬狀態會變成 NVDA 啟動時的預設值。

#### 所模擬的點字鍵盤行為
電腦鍵盤可以模擬來自使用中點顯器或者「不使用點顯器」的點字輸入。當兩個來源定義的效果發生衝突，採用的優先順序由此選項決定。預設是優先採用本附加元件所定義的效果。

#### 複製點字顯示器內容時所使用的格式

複製下來的點字內容所使用的格式，包含 Unicode 點字圖案、點字 ASCII、以及北美英文電腦點字 (NABCC)。

- [Unicode 點字圖案](https://en.wikipedia.org/wiki/Braille_Patterns): 會顯示成八點的字元。
- [點字 ASCII](https://en.wikipedia.org/wiki/Braille_ASCII): 副檔名為 .brf 的點字檔所使用的格式。
- [北美英文電腦點字 (NABCC)](https://brltty.app/doc/Manual-BRLTTY/English/BRLTTY-14.html): 請見參考網頁。注意只有對應到字元 0 至 127 的點字能被成功複製下來。（譯註：「北美英文電腦點字」即啟明學校與淡江大學視障資源中心「點字檔」之格式。）

### 備註
1. 在輸入法英數輸入模式中，點字輸入效果由 NVDA 輸入轉譯表決定。
2. 點字鍵盤單獨按第 7 或第 8 點，或者 7 8 點一起按下，無論中文、英數輸入都保留 NVDA 的原始預設行為。
3. 本附加元件不會影響點顯器的其他功能按鈕，如點字視窗前後捲動與游標定位鍵。
4. 使用者可以在 NVDA 的「輸入手勢」對話框與「點字輸入法助手設定」對話框中管理上列所有快速鍵。
5. 若組字完成，沒有報讀組成的國字或者符號，可能輸入了不合理的注音導致輸入法卡住（譯註：可用 BackSpace 或者 Esc 鍵清除錯誤的注音符號，但是使用 Esc 時須注意，若多按一次可能造成浮動組字區的其他內容被一併清除）。

## 問題與改進方向
- 目前已知的程式錯誤：
    * NVDA 的點字不會立刻反映出使用者在「點字鍵」及「忽略鍵」編輯區的輸入情形。
    * 某些情況下，本附加元件無法成功更新使用者設定。
- 未來可能的改進：
    * 允許使用者自訂本附加元見的預設狀態。
    * 允許使用者自訂符號的點字輸入方式，或者由點字轉譯表載入。
    * 讓本附加元件能與其他注音輸入法配合。

## 貢獻者
- Bo-Cheng Jhan &lt;<school510587@yahoo.com.tw>&gt;
- 黃偉豪 &lt;<hurt.nzsmr@gmail.com>&gt;

## 致謝
- 「點字輸入法助手」於 2020/01/01 至 2021/12/31 受到[社團法人臺灣視障協會](https://www.twvip.org) &lt;<vipastaiwan@gmail.com>&gt; 支持開發，特此深表感謝。

## 修改歷程

### 0.0 版
* 初始版本。

### 0.1 版
* 重構說明文件，讓使用者更易於閱讀。
* 當前景視窗改變時，清除點字緩衝區內容。

### 0.2 版
* 修正瀏覽資料夾過程中第七點 (A) 模擬的行為錯誤。
* 將 __init__.py 分開為二個檔案。

### 0.3 版
* 使輸出訊息可以翻譯成不同語言。
* 實作新的點字解析方式。
* 加入 "addon_lastTestedNVDAVersion" 資訊。
* 加入打出單獨一個注音符號的規則。
* 修正幾個數學符號的輸入點位。

### 0.4 版
* 用延遲寄送輸入的方式實現點位前綴的相容性。
* 當這次點字輸入被拒絕時，嘗試替換掉最近一方的點字輸入。
* 將 ∠ 的點位改成 ⠫⠪ (1246-246) 也就是 ← 點位的前綴。

### 0.5 版
* 重構程式碼。
* 瀏覽模式中停止用電腦鍵盤模擬點字鍵盤。
* 給予每個功能適當的文件說明與分類。

### 0.6 版
* 實現僅在輸入法英數模式中開關點字輸入的模擬與否。
* 使用 str 型別來處理 bopomofo.json 的路徑。
* 當載入點字輸入法助手的電腦鍵盤處理程序時，若有修飾鍵仍被壓下，不進行點字輸入的模擬。

### 0.7 版
* 替某些符號加入不同的點字輸入方式。
* 讓點字熱鍵可從 NVDA 輸入手勢視窗來管理。
* 調整指令的程式碼中某些書寫習慣。

### 1.0 版
* 支援基於 Python 3 的 NVDA 2019.3 版。
* 實作使用者設定的對話視窗。

### 1.1 版
* 使用更合適的音效當作打錯字的警告。
* 允許使用者自訂電腦鍵盤上點字鍵與忽略鍵的位置。
* 在設定視窗加上一個「套用」按鈕。

### 1.2 版
* 允許使用者在電腦鍵盤模擬點字鍵盤的英數模式中忽略所有非點字鍵。
* 加入與微軟注音「輸入對應」設定相應的「鍵盤對應」選項。
* 允許以 ⡼ 開頭的點字輸入韻母注音符號。

### 2.0 版
* 允許透過數字鍵盤進行一個點一個點的點字輸入。
* 加入「音效」和「沒有」兩種切換點字鍵盤模擬狀態的提示方式。
* 允許每個處理程序擁有獨立的點字鍵盤模擬狀態。
* 將快速鍵 NVDA+X 改成 NVDA+Ctrl+6。
* 把設定選項的說明加到 readme.md 中。
* 程式碼重構。

### 2.1 版
* 加入許多點字快速鍵來提高虛擬點字鍵盤使用者的操作效率。
* 放棄使用 NVDA 的 winVersion API 來避免 NVDA 2021.1 版更新 API 導致的相容性問題。
* 加入「切換英數、中文輸入模式所用的快速鍵」選項。
* 避免 keyboard.py 檔案中的 gettext 警告。
* 更新來自 AddonTemplate 的檔案。
* 對此份文件多處修正與改進。

### 2.2 版
* 實現原先的表與 Unicode 點字兩個輸入轉譯表的快速切換（第 1 3 6 點加點字空格）。
* 當使用電腦鍵盤輸入 Unicode 點字時，允許輸入 ⡀ （第七點）與 ⢀ （第八點）。
* 即使勾選「訊息顯示」中的「持續顯示」，也要適時撤除 NVDA 點字訊息。
* 避免對 "collections" 模組不當使用，改以 "collections.abc" 模組代替。
* 實現點字顯示器上的 "print screen" 功能。

### 2.3 版
* 指派不同的快速鍵給「複製點字顯示器顯示的內容」的二個模式。
* 增加強迫 NVDA 持續顯示當下訊息的功能，卻沒有預設快速鍵。
* 從 JSON 檔載入輸入法的鍵盤—符號對應關係。
* 安裝的時候，詢問使用者是否自動將輸入轉譯表改為「英文 (美國) 八點 (電腦)」。
* 採用新規則來寫附加元件的版號。
* 設計點字輸入與一般輸入模式，並在輸入法的英數輸入中實作。

### 2.4 版
* 支援 NVDA 2023.1 版。
* 增加「複製點字顯示器內容時所使用的格式」選項。
* 程式碼重構、把資料從程式碼中分離出來。
* 加入 msctf 模組，可能對開發未來的功能有所貢獻。
